ALTER FUNCTION [dbo].[GetZakazDiscount](@Zakaz int,@Price money)
RETURNS money
AS
BEGIN
-- =============================================
-- Author:		<Alexey Ivakhin>
-- Create date: <13.04.2012>
-- Update date: <14.10.2014>
-- Description:	<         (   VIP)>
-- =============================================
	-- Declare the return variable here
	DECLARE @RES money=0, @isFree bit, @FreeLimit money, @Discount money,@DiscountPercent float,
		@PriceRoundType int, @Rate int, @PriceRoundMethod int=0, @PriceRoundValue int=0;
	SELECT @Rate=Rate FROM BASE WHERE UniKey=@Zakaz;
	SELECT @PriceRoundType=PriceRoundType,@PriceRoundMethod=PriceRoundMethod,@PriceRoundValue=PriceRoundValue
	 FROM Rates WHERE UniKey=@Rate;
	
	--  VIP 
	SELECT TOP 1 @isFree=DDD.isFree, @FreeLimit=DDD.FreeLimit, @Discount=DDD.Discount,
		@DiscountPercent=DDD.DiscountPercent
		FROM VipDiscount VD LEFT JOIN Discounts DDD ON DDD.UniKey=VD.Discount WHERE	VD.Zakaz=@Zakaz;

	if @isFree IS NULL
		begin
		--     
		SELECT TOP 1 @isFree=DDD.isFree, @FreeLimit=DDD.FreeLimit, @Discount=DDD.Discount ,
			@DiscountPercent=DDD.DiscountPercent
			FROM PhoneDiscount PD LEFT JOIN Discounts DDD ON DDD.UniKey=PD.Discount WHERE	PD.Zakaz=@Zakaz;
		end;

	if @isFree IS NOT NULL
		begin
		IF @isFree=1 
			begin
            --
            if @Price>@FreeLimit SET @Res=@Price-@FreeLimit;
                else SET @Res=0;
			end
			else
			begin
			--%
			if @DiscountPercent>0
				begin
				SET @Res=@Price*(100-@DiscountPercent)/100;
				end
				else
				begin
				if @Price>=@Discount SET @Res=@Price-@Discount;
					else SET @Res=0;		
				end;
			end;
		RETURN [dbo].[GetRoundSum](@PriceRoundType,@RES,@PriceRoundMethod,@PriceRoundValue);
		end
		else
		begin
		--   
		--DECLARE @isHasCash bit=0;
		SELECT @DiscountPercent=cc.Discount FROM CardOrderLink COL LEFT JOIN Cards cc ON cc.UniKey=COL.[Card]
			WHERE COL.[Order]=@Zakaz;
		--if (ISNULL(@isHasCash,0)=0) 
		SET @DiscountPercent=ISNULL(@DiscountPercent,0);
		if(@DiscountPercent>0) SET @Res=@Price*(100-@DiscountPercent)/100;
			ELSE
			SET @RES=@Price;
		end;
	RETURN [dbo].[GetRoundSum](@PriceRoundType,@RES,@PriceRoundMethod,@PriceRoundValue);
END
