ALTER PROCEDURE [dbo].[P_DiscountPhone] (@R int=NULL,@UniKey int=null OUTPUT,
@Surprise	varchar(128)=null,@isDriverRecalc	bit	=null, @Zakaz int=null,@PhoneKey int=null,
@CN3	int	=null,@DiscountSum money=0, @CN2	int	=null,@CN1	int	=null,@FreeLimit	money	=null,@Discount money=0, @isManual bit=0,
@isFree	bit	=null,@DateEnd	datetime=null,@DateBegin	datetime=null, @UserCreated int=null,
@DiscountPercent float=0, @ActionType int=0,
@UserUpdated int=null, @isEnabled bit=1,@SelectOrder varchar(2000)=null,@DiscountName	varchar(128)=null OUTPUT)
AS
BEGIN
-- =============================================
-- Author:		<Alexey Ivakhin>
-- Create date: <09.06.2011>
-- Update date: <15.10.2014>
-- Description:	<      ,    >
-- =============================================
	DECLARE @Q varchar(4000), @tmp int, @StartTravelCount int;
	--SET NOCOUNT ON;
	if @R=1 /*      */
		begin
		SELECT vvv.*,
			(SELECT COUNT(VD.UniKey) FROM PhoneDiscount VD  WITH(nolock) WHERE VD.PhoneKey=vvv.Unikey AND VD.Zakaz IS NULL) As DiscountCount,
			(SELECT TOP 1 VD.UniKey FROM PhoneDiscount VD  WITH(nolock) WHERE VD.PhoneKey=vvv.Unikey AND VD.Zakaz=@Zakaz) As DiscountPhoneKey
			FROM BLACKLISTTEL vvv   WITH(nolock) WHERE vvv.UniKey=@Unikey;
		end;
	if @R=2 /*   */
		begin
		SELECT VD.*,DDD.isFree, DDD.FreeLimit,DDD.Discount FROM PhoneDiscount VD LEFT JOIN Discounts DDD ON DDD.UniKey=VD.Discount WHERE	VD.UniKey=@UniKey;
		end;
	--   1 
	if @R=5
		begin
		SET @Q='SELECT VD.*,DDD.DiscountName, DDD.Surprise, CASE VD.isFree WHEN 1 THEN '' '' ELSE '''' END as isFreeName,
		 CASE WHEN VD.Zakaz IS NULL THEN '''' ELSE '''' END as isUse,
		 (SELECT FIO FROM USERS  WITH(nolock) WHERE UniKey=VD.UserCreated) as FIO
		  FROM PhoneDiscount VD  WITH(nolock) LEFT JOIN Discounts DDD ON DDD.UniKey=VD.Discount WHERE 1=1';
		if @PhoneKey IS NOT NULL SET @Q=@Q+' AND VD.PhoneKey='+STR(@PhoneKey);
		if (@SelectOrder is NOT NULL) SET @Q=@Q+@SelectOrder; else SET @Q=@Q+' ORDER BY DateCreated DESC';
		--RaISERROR 99999 @SelectOrder;
		Exec (@Q);
		end;
	--  1 
	if @R=7
		begin
		INSERT INTO  PhoneDiscount (isManual, DiscountSum,isFree, Discount,PhoneKey, UserCreated, UserUpdated,
			DiscountPercent,ActionType) VALUES (@isManual, @DiscountSum,	@isFree,@Discount,@PhoneKey, @UserCreated,@UserUpdated,
			@DiscountPercent,@ActionType);
		SET @UniKey=SCOPE_IDENTITY();
		end;
	--  1 phone
	if @R=8
		begin
		UPDATE PhoneDiscount SET isManual=@isManual, DiscountSum=@DiscountSum,isFree=@isFree, Discount=@Discount,
			PhoneKey=@PhoneKey, UserUpdated=@UserUpdated, DiscountPercent=@DiscountPercent,
			ActionType=@ActionType WHERE UniKey=@UniKey;
		end;
	if @R=9
		begin
		DELETE FROM PhoneDiscount WHERE UniKey=@UniKey;	
		end;
	-- 
	if @R=10
		begin
		UPDATE PhoneDiscount SET isEnabled=0 WHERE UniKey=@UniKey;
		end;
	-- 
	if @R=11
		begin
		UPDATE PhoneDiscount SET  isEnabled=1 WHERE UniKey=@UniKey;
		end;
	--     
	if @R=12
		begin
		---  phone
		SELECT TTT.*, CASE WHEN (TTT.DiscountCount1-TTT.ZakazCount)>0 THEN (TTT.DiscountCount1-TTT.ZakazCount)  ELSE 0 END
			  As DiscountCount FROM (SELECT 
			[dbo].[GetOrderCount](DDD.CarType,DDD.RegionFrom, DDD.DateBeginType, DDD.DateBegin, DDD.DateEnd,NULL,@PhoneKey) as ZakazCount, 
			((isNull((SELECT COUNT(*) FROM PhoneDiscount WITH(nolock) WHERE isManual=0 AND PhoneKey=@PhoneKey 
				AND Discount=DDD.UniKey),0)+1)*CN1+CN2-1) as DiscountCount1,
				(SELECT COUNT(unikey) FROM PhoneDiscount WITH(nolock) WHERE isManual=0 AND PhoneKey=@PhoneKey 
				AND Discount=DDD.UniKey) as DiscountCountAll,
			DDD.* FROM Discounts DDD  WITH(nolock) WHERE DateBegin<GETDATE() AND (DateEnd>=GETDATE() OR DateEnd IS NULL)) TTT
			ORDER BY TTT.DateEnd DESC;
		end;
end;