ALTER FUNCTION [dbo].[GetRoundSum](@PriceRoundType int, @sum money, @PriceRoundMethod int=0, @PriceRoundValue int=0)
RETURNS money
AS
BEGIN
-- =============================================
-- Author:		<Alexey Ivakhin>
-- Create date: <14/01/2013
-- Update date: <06/10/2014
-- Description:	<       >
-- =============================================
	DECLARE @RES money=0, @tmp money;
	    /* 0:  
	    1: 0 ( )
	    2: 5 (  5)
	    3: 10 (  10)
	    4: 100 (  100)
	    5: 50 (  50)
	    6: 
	    */	
	--
	if @PriceRoundMethod=0
		begin
		if (@PriceRoundType=0) RETURN @sum;
		if (@PriceRoundType=1) RETURN ROUND(@sum,0);
		if (@PriceRoundType=2) 
			begin
			SET @tmp=@sum%5;
			if(@tmp<2.5) SET @RES=@sum-@tmp; else SET @RES=@sum-@tmp+5;
			end;
		if (@PriceRoundType=3) RETURN ROUND(@sum,-1);
		if (@PriceRoundType=4) RETURN ROUND(@sum,-2);	
		if (@PriceRoundType=5) 
			begin
			SET @tmp=@sum%50;
			if(@tmp<25) SET @RES=@sum-@tmp; else SET @RES=@sum-@tmp+50;
			end;
		if (@PriceRoundType=6) 
			begin
			SET @tmp=@sum%@PriceRoundValue;
			if(@tmp<(@PriceRoundValue/2)) SET @RES=@sum-@tmp; else SET @RES=@sum-@tmp+@PriceRoundValue;
			end;			
		end;
	--  
	if @PriceRoundMethod=1
		begin
		if (@PriceRoundType=0) RETURN @sum;
		if (@PriceRoundType=1) 
			begin
			SET @tmp=FLOOR(@sum);	
			if((@sum-@tmp)>0) SET @RES=@tmp+1;
				else SET @RES=@tmp;
			end;
		SET @RES=@sum;
		if (@PriceRoundType=2) 
			begin
			SET @tmp=@sum%5;
			if(@tmp>0) SET @RES=@sum-@tmp+5;
			end;
		if (@PriceRoundType=3) 			
			begin
			SET @tmp=@sum%10;
			if(@tmp>0) SET @RES=@sum-@tmp+10;
			end;

		if (@PriceRoundType=4) 			
			begin
			SET @tmp=@sum%100;
			if(@tmp>0) SET @RES=@sum-@tmp+100;
			end;
		if (@PriceRoundType=5) 
			begin
			SET @tmp=@sum%50;
			if(@tmp>0) SET @RES=@sum-@tmp+50;
			end;
		if (@PriceRoundType=6) 
			begin
			SET @tmp=@sum%@PriceRoundValue;
			if(@tmp>0) SET @RES=@sum-@tmp+@PriceRoundValue;
			end;
		end;
	RETURN @RES;
END
