SET NUMERIC_ROUNDABORT OFF
GO
SET ANSI_PADDING, ANSI_WARNINGS, CONCAT_NULL_YIELDS_NULL, ARITHABORT, QUOTED_IDENTIFIER, ANSI_NULLS ON
GO
SET XACT_ABORT ON
GO
SET TRANSACTION ISOLATION LEVEL SERIALIZABLE
GO
PRINT N'Altering [dbo].[BASE]'
GO
ALTER TABLE [dbo].[BASE] ALTER COLUMN [OTHER] [varchar] (4000) COLLATE SQL_Latin1_General_CP1251_CI_AS NULL
GO
PRINT N'Refreshing [dbo].[v_zakaz_ultra]'
GO
EXEC sp_refreshview N'[dbo].[v_zakaz_ultra]'
GO
PRINT N'Refreshing [dbo].[v_sms_wait]'
GO
EXEC sp_refreshview N'[dbo].[v_sms_wait]'
GO
PRINT N'Altering [dbo].[base_up]'
GO
SET ANSI_NULLS OFF
GO
ALTER PROCEDURE [dbo].[base_up](@UniKey int=NULL OUTPUT, @R int=10001, @Driver int=NULL,@DATEIN datetime=NULL,@PLACE varchar(128)=NULL,@zakazplace int=null,
@CurrentUserUniKey int=null,@LOCKBAS int=null, @DATE1 datetime=NULL,@DATE2 datetime=NULL,
@STREETFROM varchar(40)=null,@CLIENTTEL varchar(32)=null,@OtkazClienta int=null,@STREETTO varchar(40)=null,@TimeOut DATETIME=null,
@ZoneFrom int=null,@ZoneTo int=null,@Price money=null,@TaxiNum int=null,@Other varchar(4000)=null,@HOUSEFROM varchar(32)=null,@HOUSETO varchar(32)=null,
@TIMETOCLIENT int=null,@V_OPERATOR int=null,@V_RADIST int=null,@PREDV_DATETIME datetime=null,@PREDV_MIN int=null,
@RadistView int=null,@vip int=null,@hourpay smallint=NULL, @ZAKAZ_TYPE smallint=NULL,@CloseOrderInFlight int=0,
@DateBeginHourPay datetime=null, @DateEndHourPay datetime=null, @KmBeginHourPay float=0, @KmEndHourPay float=0, @GetAddSum money=null,
@ModuleType int=null, @isPredv bit=0, @isOwn bit=NULL, 
@isAutoFineEnabled bit=1, @UltraKey int=NULL, @PriceFull money=null, @DiscountVIPKey int=0,
@isKmEnabled bit=null,@isComplexEnabled bit=null,@HourPayType int=null,
@PhoneKey int=NULL,@isDiscount bit=0,@isTaximeter bit=0,
@DiscountPhoneKey int=0,@Rate int=NULL,@isClearing bit=0,@isAddMinPrice bit=0, @RadistToOperatorParam bit=0,
@OrderSrc int=null, @LPSrc int=null, @DateBegin datetime=null, @DateTaxiWait datetime=null, @DateTaxiGo datetime=null,
@GeoFrom int=null, @GeoTo int=null, @Card int=null, @StreetFromKey int=null, @LatFrom float=null,@LonFrom float=null,
@LatTo float=null,@LonTo float=null, @UltraExchange int=null, @PreCalculatedPrice money=0,
@Finder varchar(256)=NULL,
@zakazplaceS varchar(512)=null,
@SelectOrder varchar(256)=NULL)  AS
BEGIN
-- =============================================
-- Author:		<Alexey Ivakhin>
-- Create date: <18.11.2009>
-- Update date: <08.09.2014>
-- Description:	<   >
-- =============================================
SET DATEFORMAT dmy;
SET NOCOUNT ON
DECLARE @myuser_r INT,@myuser_otdel INT,@SQLString nvarchar(4000),@zOldDriver int, @TmpStr varchar(128)=NULL;
DECLARE @StatRefusal int, @StatCallAll int, @OldOtkazClienta int, @OldZakazPlace int, @OldCard int, @TMP int, @isDiscountOld int,
	@isShowAllGeoRegion bit=1, @isShowAllZakazType bit=1, @isSaveHouse bit=0, @isSetDriverManual bit,
	@isLoadDriversFromTask bit;
	if @R=10001 --,       
		begin
		SELECT 1 as Integer;
		return;
		end;
	if @R=1 /**/
		begin
		SELECT TOP 1 @isLoadDriversFromTask=isLoadDriversFromTask FROM PROPERTIES;
		
		SET @SQLString = N'SELECT bbb.*,ZP.PLACE_NAME,ZP.ImageIndex, isnull(ZTC.ClearingPrice,0.0) as ClearingPrice,ZTC.Contract,GR.NameGeoRegion as NameGeoRegionFrom, ZO.NameZone,ZT.TC_image_index,ZT.ZAKAZ_TYPE as ZakazTypeName, ZT.CellColor as CarTypeCellColor,
		(CASE WHEN bbb.UltraKey IS NOT NULL AND bbb.isOwn=1 THEN (SELECT UC.GOV_NUMBER FROM UltraCars UC WHERE UC.UniKey=bbb.UltraCar)ELSE(';
		if @isLoadDriversFromTask=1
			SET @SQLString =@SQLString + N'SELECT TMP_GOV_NUMBER FROM DriversPlace WHERE Driver=bbb.Driver';
			ELSE
			SET @SQLString =@SQLString + N'SELECT GOV_NUMBER FROM Cars WHERE UniKey=[dbo].[GetCarByDriver](DRV.UNIKEY,CASE WHEN bbb.DateBegin IS NOT NULL THEN DateBegin ELSE DateIn END)';
		SET @SQLString =@SQLString + N')END)as GOV_NUMBER,
		CASE WHEN bbb.ZAKAZPLACE<100 THEN CAST(GETDATE()-isnull(bbb.DATETIME_OF_T,GETDATE()) as time) ELSE NULL END  as TIME_ZP_CHANGE, UT.TaxiName as UltraTaxiName, UT.DispatchPhone, LPSrc.TaxiName, OrderSrc.SrcName,
		GRT.NameGeoRegion as NameGeoRegionTo, ZOT.NameZone as NameZoneTo, UOS.UltraOrderStateName
		FROM BASE bbb WITH (nolock) LEFT JOIN ZAKAZ_PLACE ZP ON ZP.ZPLACE=bbb.ZAKAZPLACE
		LEFT JOIN Zakaz_Type ZT ON ZT.UNIKEY=bbb.Zakaz_Type
		LEFT JOIN Zone ZO ON ZO.UNIKEY=bbb.ZoneFrom
		LEFT JOIN GeoRegions GR ON GR.UniKey=bbb.GeoFrom
		LEFT JOIN GeoRegions GRT ON GRT.UniKey=bbb.GeoTo
		LEFT JOIN Zone ZOT ON ZOT.UNIKEY=bbb.ZoneTo
		LEFT JOIN UltraOrderState UOS ON UOS.UltraOrderState=bbb.UltraOrderState
		LEFT JOIN Drivers DRV ON DRV.UniKey=bbb.Driver
		LEFT JOIN UltraTaxi UT ON UT.ClientId=bbb.UltraAcceptor
		LEFT JOIN LPSrc ON LPSrc.UniKey=bbb.LPSrc
		LEFT JOIN OrderSrc ON OrderSrc.UniKey=bbb.OrderSrc
		LEFT JOIN ZakazToContract ZTC ON ZTC.Zakaz=bbb.UniKey WHERE 1=1 ';

		if @zakazplaceS IS NOT null SET @SQLString =@SQLString + N' AND zakazplace'+@zakazplaceS;
		if @zakazplace IS NOT NULL SET @SQLString =@SQLString + N' AND zakazplace=@zakazplace';
		if @LOCKBAS IS NOT NULL SET @SQLString =@SQLString + N' AND LOCKBAS=@LOCKBAS';
		if (@RadistToOperatorParam=1) AND (@CurrentUserUniKey IS NOT NULL) SET @SQLString =@SQLString + N' AND bbb.UniKey IN (SELECT BaseKey FROM History WHERE BaseKey=bbb.UniKey AND UserKey=@CurrentUserUniKey)';
		if @Date1 IS NOT NULL SET @SQLString =@SQLString + N' AND (bbb.DateIn>=@Date1 AND bbb.DateIn<=@Date2)';

		if @STREETFROM IS NOT NULL SET @SQLString =@SQLString + N' AND STREETFROM LIKE ''%'+@STREETFROM+'%''';
		if (@STREETTO IS NOT NULL) SET @SQLString =@SQLString + N' AND STREETTO LIKE ''%'+@STREETTO+'%''';
		if @CLIENTTEL IS NOT NULL SET @SQLString =@SQLString + N' AND CLIENTTEL=@CLIENTTEL';
		if @ModuleType IS NOT NULL SET @SQLString =@SQLString + N' AND ModuleType='+CAST(@ModuleType AS nvarchar(10));
		if @TaxiNum IS NOT NULL
			begin
			if @TaxiNum=-1 	SET @SQLString =@SQLString + N' AND (Driver IS NOT NULL)';
				else
				if @TaxiNum=-2 	SET @SQLString =@SQLString + N' AND isPredv=1';
					else
					SET @SQLString =@SQLString + N' AND TaxiNum=@TaxiNum';
			end;
		if (@CurrentUserUniKey IS NOT NULL)
			begin
			SELECT @isShowAllZakazType=isShowAllZakazType, @isShowAllGeoRegion=isShowAllGeoRegion FROM USERS WHERE UniKey=@CurrentUserUniKey;
			--    
			if @isShowAllGeoRegion=0 SET @SQLString =@SQLString + N' AND bbb.GeoFrom IN (SELECT GeoRegion FROM User_GeoRegion_Link WHERE UserKey='+CAST(@CurrentUserUniKey as varchar(12))+')';
			--     
			if @isShowAllZakazType=0 SET @SQLString =@SQLString + N' AND bbb.ZAKAZ_TYPE IN (SELECT ZakazType FROM User_ZakazType_Link WHERE UserKey='+CAST(@CurrentUserUniKey as varchar(12))+')';
			end;
		if @RadistView IS NOT NULL
			begin 
			SET @SQLString =@SQLString + N'  OR (bbb.ZakazPlace=11 AND (DATEADD(mi,-bbb.PREDV_MIN,bbb.PREDV_DATETIME)-GETDATE())<0) ';
			if @SelectOrder IS NOT NULL SET @SQLString =@SQLString + @SelectOrder;
				else
				SET @SQLString =@SQLString + N' ORDER BY bbb.V_RADIST ';
			end
			else
			begin
			if @SelectOrder IS NOT NULL SET @SQLString =@SQLString + @SelectOrder;
				else
				SET @SQLString =@SQLString + N' ORDER BY bbb.ZAKAZPLACE,bbb.DateIn ';
			end;			
		--RaISERROR 99999 @SQLString;
		EXEC sp_executesql @SQLString,N'@zakazplaceS varchar(256)=NULL,@zakazplace int, @Date1 datetime, @Date2 datetime,@LOCKBAS int,@CurrentUserUniKey int,@CLIENTTEL varchar(32),@TaxiNum int',@zakazplaceS,
			@zakazplace,@Date1,@Date2,@LOCKBAS,@CurrentUserUniKey,@CLIENTTEL,@TaxiNum;
		end;

	if @R=2 /**/
		begin
		-- 
		SELECT @isDiscountOld=isDiscount, @zOldDriver=Driver, @DATEIN=DATEIN, @OldOtkazClienta=OtkazClienta,
			@OldZakazPlace=ZakazPlace FROM BASE WHERE UniKey=@UniKey;
		--     
		SET @ClientTel=dbo.GetPhoneInternational(@ClientTel);
		if(LEN(@ClientTel)=0) SET @PhoneKey=NULL;	--  ,   
		--   ""
		if @ZakazPlace=1 AND (@Driver IS NULL) AND EXISTS(SELECT JisEnabled FROM PROPERTIES WHERE JisEnabled>0)
			AND (@ZoneFrom IS NOT NULL OR (@ZoneFrom IS NULL AND EXISTS(SELECT JNewZakazSend FROM PROPERTIES WHERE JNewZakazSend=0)))
			begin
			if EXISTS(SELECT Unikey FROM DriversPlace WITH (nolock) WHERE ClientType IN (SELECT UniKey FROM DriverClientType WHERE isMobile=1) AND isOnline=1)
				SET @ZakazPlace=14;
			end;
		-- 
		if (@isPredv=0 AND @zakazplace=11) SET @isPredv=1;		
		if (@isPredv=0) SET @PREDV_DATETIME=NULL;
		--  
		if EXISTS(SELECT Unikey FROM VipDiscount WHERE Zakaz=@UniKey AND UniKey!=@DiscountVIPKey)
				UPDATE VipDiscount SET Zakaz=NULL WHERE Zakaz=@UniKey;			
		if (@vip IS NOT NULL) AND (@DiscountVIPKey IS NOT NULL)
			begin
			UPDATE VipDiscount SET Zakaz=@UniKey WHERE UniKey=@DiscountVIPKey;
			end;
		--     - 
		UPDATE PhoneDiscount SET Zakaz=NULL WHERE Zakaz=@UniKey  AND (@DiscountPhoneKey IS NULL OR UniKey!=@DiscountPhoneKey);			
		
		if @isDiscount=1
			begin
			if (@DiscountPhoneKey IS NOT NULL)
				begin
				if NOT EXISTS(SELECT * FROM PhoneDiscount WHERE (Zakaz IS NOT NULL) AND Zakaz!=@UniKey  AND UniKey=@DiscountPhoneKey)
					UPDATE PhoneDiscount SET Zakaz=@UniKey WHERE UniKey=@DiscountPhoneKey;
				end;
			end
		-- 
		SELECT @OldCard=UniKey FROM CardOrderLink COL WHERE COL.[Order]=@UniKey;
		if(isnull(@OldCard,0)!=@Card) 
			begin
			if(@OldCard IS NOT NULL) DELETE FROM CardOrderLink WHERE [Order]=@UniKey;
			if(@Card IS NOT NULL) INSERT INTO CardOrderLink ([Card],[Order],[sum]) VALUES (@Card,@UniKey,0);
			end;
			
		--     ,     
		if (ISNULL(@LatFrom,0)=0) AND (@StreetFromKey IS NOT NULL) AND (LEN(@HOUSEFROM)>0)
			begin
			SET @TmpStr=RTRIM(LTRIM(@HOUSEFROM));
			SET @TMP=ISNULL(CHARINDEX(' ',@TmpStr),0);
			if(@TMP>0) SET @TmpStr=SUBSTRING(@TmpStr,1,@TMP-1);
			SET @TMP=ISNULL(CHARINDEX('.',@TmpStr),0);
			if(@TMP>0) SET @TmpStr=SUBSTRING(@TmpStr,1,@TMP-1);
			SET @TMP=ISNULL(CHARINDEX(',',@TmpStr),0);
			if(@TMP>0) SET @TmpStr=SUBSTRING(@TmpStr,1,@TMP-1);

			SELECT @LonFrom=lon,@LatFrom=lat FROM COD_HOUSE WHERE Street=@StreetFromKey AND House LIKE @TmpStr;
			if (ISNULL(@LatFrom,0)!=0) UPDATE BASE SET LatFrom=@LatFrom,LonFrom=@LonFrom WHERE UNIKEY=@UniKey;			
			end;			
		
		BEGIN TRANSACTION;
		UPDATE base SET PhoneKey=@PhoneKey,isDiscount=@isDiscount,
			Place=@Place,StreetFrom=@StreetFrom,StreetTo=@StreetTo,ZoneFrom=@ZoneFrom,ZoneTo=@ZoneTo,Price=@Price,ClientTel=@ClientTel,
			TaxiNum=@TaxiNum,ZakazPlace=@ZakazPlace,Other=@Other,TimeOut=@TimeOut,OtkazClienta=@OtkazClienta,
			HOUSEFROM=@HOUSEFROM,HOUSETO=@HOUSETO,TIMETOCLIENT=@TIMETOCLIENT,V_OPERATOR=@V_OPERATOR,V_RADIST=@V_RADIST,
			PREDV_DATETIME=@PREDV_DATETIME,PREDV_MIN=@PREDV_MIN,LASTUPDATE=CURRENT_TIMESTAMP,vip=@vip,hourpay=@hourpay,ZAKAZ_TYPE=@ZAKAZ_TYPE,
			DateBeginHourPay=@DateBeginHourPay,DateEndHourPay=@DateEndHourPay,
			KmBeginHourPay=@KmBeginHourPay,KmEndHourPay=@KmEndHourPay, GetAddSum=@GetAddSum,ModuleType=@ModuleType,
			isPredv=@isPredv, isAutoFineEnabled=@isAutoFineEnabled, PriceFull=@PriceFull,
			isKmEnabled=@isKmEnabled,isComplexEnabled=@isComplexEnabled, HourPayType=@HourPayType,
			Rate=@Rate,isClearing=@isClearing,isTaximeter=@isTaximeter,isAddMinPrice=@isAddMinPrice,
			LPSrc=@LPSrc, LatFrom=@LatFrom,LonFrom=@LonFrom,LatTo=@LatTo,LonTo=@LonTo,
			GeoFrom=@GeoFrom,GeoTo=@GeoTo,StreetFromKey=@StreetFromKey, PreCalculatedPrice=@PreCalculatedPrice
			WHERE UniKey=@UniKey
		--
		UPDATE base SET DRIVER=@Driver WHERE UniKey=@UniKey;
		COMMIT TRANSACTION;
		--    
		if (@CloseOrderInFlight=1 AND @TaxiNum!=0 AND (@Driver is NOT NULL) AND @ZakazPlace!=8 AND @ZakazPlace!=100) 
			begin
			exec [ProcCloseOrderInFlight] 1,@UniKey,@TAXINUM,@CLIENTTEL,@OtkazClienta,@Driver,@ZoneFrom,@ZoneTo,@OldOtkazClienta,@ZakazPlace,@OldZakazPlace;
			end;
		exec [ProcCloseOrderInFlight] 2,@UniKey,@TAXINUM,@CLIENTTEL,@OtkazClienta,@zOldDriver,@ZoneFrom,@ZoneTo,@OldOtkazClienta,@ZakazPlace,@OldZakazPlace;
		--  
		if (@zOldDriver IS NOT NULL)
			if (@zOldDriver!=@Driver OR @Driver IS NULL) UPDATE DriversPlace SET isFree=1 WHERE Driver=@zOldDriver;

		--  
		if (@Driver IS NOT NULL) AND (@zOldDriver IS NULL) SET @isSetDriverManual=1;
			ELSE SET @isSetDriverManual=0;
		EXEC [dbo].[history_up] @R=3,@BaseKey=@UniKey,@UserKey=@CurrentUserUniKey,@ActionKey=@ZakazPlace,
			@isSetDriverManual=@isSetDriverManual;

		return;
		end;
	if @R=3 /**/
		begin
		/* */
		--     
		SET @ClientTel=dbo.GetPhoneInternational(@ClientTel);
		--   ""
		if @ZakazPlace=1 AND (@Driver IS NULL) AND EXISTS(SELECT JisEnabled FROM PROPERTIES WHERE JisEnabled>0)
			AND (@ZoneFrom IS NOT NULL OR (@ZoneFrom IS NULL AND EXISTS(SELECT JNewZakazSend FROM PROPERTIES WHERE JNewZakazSend=0)))
			if EXISTS(SELECT Unikey FROM DriversPlace WHERE ClientType IN (1,4,5) AND isOnline=1)
				SET @ZakazPlace=14;
		-- 
		if (@isPredv=0 AND @zakazplace=11) SET @isPredv=1;
		if (@isPredv=0) SET @PREDV_DATETIME=NULL;
		-- 
		if (@LPSrc IS NULL) 
			SELECT TOP 1 @LPSrc=UniKey FROM LPSrc WHERE isEnabled=1;
		
		INSERT INTO base (DateIn,Place,StreetFrom,StreetTo,ZoneFrom,ZoneTo,Price,ClientTel,TaxiNum,ZakazPlace,Other,
		Lockbas,TimeOut,OtkazClienta,HOUSEFROM,HOUSETO,TIMETOCLIENT,V_OPERATOR,V_RADIST,PREDV_DATETIME,
		PREDV_MIN,LASTUPDATE,vip,hourpay,ZAKAZ_TYPE,DRIVER,DateBeginHourPay,DateEndHourPay,KmBeginHourPay,KmEndHourPay,GetAddSum,
		ModuleType,isPredv,isAutoFineEnabled,PriceFull,	isKmEnabled,isComplexEnabled, HourPayType,PhoneKey,isDiscount,
		Rate,isClearing,isTaximeter,isAddMinPrice,OrderSrc, LPSrc, GeoFrom,GeoTo,StreetFromKey,LatFrom,LonFrom,
		LatTo,LonTo, UltraExchange,PreCalculatedPrice) 
		VALUES (
		GETDATE(),@Place,@StreetFrom,@StreetTo,@ZoneFrom,@ZoneTo,@Price,@ClientTel,@TaxiNum,@ZakazPlace,@Other,
		0,NULL,@OtkazClienta,@HOUSEFROM,@HOUSETO,@TIMETOCLIENT,@V_OPERATOR,@V_RADIST,@PREDV_DATETIME,
		@PREDV_MIN,GETDATE(),@vip,@hourpay,@ZAKAZ_TYPE,@Driver,@DateBeginHourPay,@DateEndHourPay,
		@KmBeginHourPay,@KmEndHourPay,@GetAddSum,@ModuleType,@isPredv,@isAutoFineEnabled,@PriceFull,@isKmEnabled,
		@isComplexEnabled, @HourPayType,@PhoneKey,@isDiscount,@Rate,@isClearing,@isTaximeter,@isAddMinPrice,
		@OrderSrc,@LPSrc,@GeoFrom,@GeoTo,@StreetFromKey,@LatFrom,@LonFrom,@LatTo,@LonTo, @UltraExchange,@PreCalculatedPrice);

		SET @UniKey=SCOPE_IDENTITY();
		--  
		if (@vip IS NOT NULL) AND (@DiscountVIPKey IS NOT NULL)
			begin
			UPDATE VipDiscount SET Zakaz=@UniKey WHERE UniKey=@DiscountVIPKey;
			end;
		--    
		if @isDiscount=1
			begin
			if (@DiscountPhoneKey IS NOT NULL)
				begin
				if NOT EXISTS(SELECT * FROM PhoneDiscount WHERE (Zakaz IS NOT NULL) AND UniKey=@DiscountPhoneKey)
					UPDATE PhoneDiscount SET Zakaz=@UniKey WHERE UniKey=@DiscountPhoneKey;
				end;
			end;
		-- 
		if(@Card IS NOT NULL) 
			INSERT INTO CardOrderLink ([Card],[Order],[sum]) VALUES (@Card,@UniKey,0);
		/*
			ELSE
			begin
			--     WEB 
			if @ModuleType=3 AND @LPSrc=x	--   
				begin
				SET @Card=13;	--      
				INSERT INTO CardOrderLink ([Card],[Order],[sum]) VALUES (@Card,@UniKey,0);
				UPDATE BASE SET isDiscount=1 WHERE UniKey=@UniKey;
				end;
			--     SMS 
			if @ModuleType=2
				begin
				SET @Card=13;	--      
				INSERT INTO CardOrderLink ([Card],[Order],[sum]) VALUES (@Card,@UniKey,0);
				UPDATE BASE SET isDiscount=1 WHERE UniKey=@UniKey;
				end;
			end;
		*/	
		--  
		if (@isOwn IS NOT NULL) UPDATE BASE SET isOwn=@isOwn WHERE UNIKEY=@UniKey;
		if (@UltraKey IS NOT NULL) UPDATE BASE SET UltraKey=@UltraKey WHERE UNIKEY=@UniKey;		
		--    
		if (@CloseOrderInFlight=1 AND @TaxiNum!=0 AND (@Driver IS NOT NULL) AND @ZakazPlace!=8 AND @ZakazPlace!=100)
			begin
			Exec [ProcCloseOrderInFlight] 1,@UniKey,@TaxiNum;
			end;

		--    
		if(@PhoneKey IS NULL AND LEN(@ClientTel)>0)
		begin
			-- 
			Exec ModifyPhoneStats @ClientTel, 0, 0,@PhoneKey OUTPUT;
			--   
			UPDATE BASE SET PhoneKey=@PhoneKey WHERE UNIKEY=@UniKey;
		end;
		--   /
		if (@StreetFromKey IS NOT NULL) AND EXISTS (SELECT * FROM PROPERTIES WHERE isSaveHouse=1) 
			begin
			SET @TmpStr=RTRIM(LTRIM(@HOUSEFROM));
			SET @TMP=ISNULL(CHARINDEX(' ',@TmpStr),0);
			if(@TMP>0) SET @TmpStr=SUBSTRING(@TmpStr,1,@TMP-1);
			SET @TMP=ISNULL(CHARINDEX('.',@TmpStr),0);
			if(@TMP>0) SET @TmpStr=SUBSTRING(@TmpStr,1,@TMP-1);
			SET @TMP=ISNULL(CHARINDEX(',',@TmpStr),0);
			if(@TMP>0) SET @TmpStr=SUBSTRING(@TmpStr,1,@TMP-1);
						
			if NOT EXISTS (SELECT * FROM COD_HOUSE WHERE House LIKE @TmpStr AND Street=@StreetFromKey)
				begin
				INSERT INTO COD_HOUSE(House,Street,lat,lon) VALUES (@TmpStr,@StreetFromKey,@LatFrom,@LonFrom);
				end;
			end;
			
		--     ,     
		if (ISNULL(@LatFrom,0)=0) AND (@StreetFromKey IS NOT NULL) AND (LEN(@HOUSEFROM)>0)
			begin
			SET @TmpStr=RTRIM(LTRIM(@HOUSEFROM));
			SET @TMP=ISNULL(CHARINDEX(' ',@TmpStr),0);
			if(@TMP>0) SET @TmpStr=SUBSTRING(@TmpStr,1,@TMP-1);
			SET @TMP=ISNULL(CHARINDEX('.',@TmpStr),0);
			if(@TMP>0) SET @TmpStr=SUBSTRING(@TmpStr,1,@TMP-1);
			SET @TMP=ISNULL(CHARINDEX(',',@TmpStr),0);
			if(@TMP>0) SET @TmpStr=SUBSTRING(@TmpStr,1,@TMP-1);

			SELECT @LonFrom=lon,@LatFrom=lat FROM COD_HOUSE WHERE Street=@StreetFromKey AND House LIKE @TmpStr;
			if (ISNULL(@LatFrom,0)!=0) UPDATE BASE SET LatFrom=@LatFrom,LonFrom=@LonFrom WHERE UNIKEY=@UniKey;			
			end;
		
		exec [ProcCloseOrderInFlight] 2,@UniKey,@TAXINUM,@CLIENTTEL,@OtkazClienta,NULL,@ZoneFrom,@ZoneTo,0,@ZakazPlace,0;
		--         
		if(@PhoneKey IS NOT NULL)
			begin
			SELECT @TmpStr=StreetFrom FROM BLACKLISTTEL WHERE UniKey=@PhoneKey;
			SET @TmpStr=ISNULL(@TmpStr,'');
			if (LEN(@TmpStr)=0) 
				begin
/*				UPDATE BLACKLISTTEL SET StreetFrom=@STREETFROM,StreetTo=@STREETTO,HouseFrom=@HOUSEFROM,
					GeoRegionFrom=(SELECT GeoRegion FROM Zone zz WHERE zz.UNIKEY=@ZoneFrom),
					GeoRegionTo=(SELECT GeoRegion FROM Zone zz WHERE zz.UNIKEY=@ZoneTo) WHERE UniKey=@PhoneKey;
*/
				exec [dbo].[P_ROUTES_BY_PHONE] @R=2,@PhoneKey=@PhoneKey,
					@GeoRegionFrom=@GeoFrom,@StreetFrom=@StreetFrom,@HouseFrom=@HouseFrom,@LatFrom=@LatFrom,@LonFrom=@LonFrom,
					@GeoRegionTo=@GeoTo,@StreetTo=@StreetTo,@HouseTo=@HouseTo,@LatTo=@LatTo,@LonTo=@LonTo;
				end;
			end
		--  
		if @Driver IS NOT NULL SET @isSetDriverManual=1;
			ELSE SET @isSetDriverManual=0;
		EXEC [dbo].[history_up] @R=3,@BaseKey=@UniKey,@UserKey=@CurrentUserUniKey,@ActionKey=@ZakazPlace,
			@isSetDriverManual=@isSetDriverManual;

		return;
		end;
	if @R=4 /* 1 */
		begin
		SELECT bbb.*,ZP.PLACE_NAME, isnull(ZTC.ClearingPrice,0.0) as ClearingPrice,ZTC.Contract,ZTC.PIN,
			(SELECT GeoRegion FROM ZONE WHERE UNIKEY=bbb.ZONEFROM) as RegionFrom,
			(SELECT GeoRegion FROM ZONE WHERE UNIKEY=bbb.ZONETO) as RegionTo,
			[dbo].[GetGovNumberByTaxiNum] (bbb.TAXINUM, case WHEN bbb.DateBegin IS NOT NULL THEN bbb.DateBegin ELSE bbb.DATEIN END) as GOV_NUMBER,
			[dbo].[GetFIO](bbb.DRIVER) as DriverFIO,
			(SELECT cc.CarType FROM Cars cc WHERE cc.UniKey=[dbo].[GetCarByDriver](bbb.Driver,GETDATE())) as DriverCarType,
			COL.[sum] as CardSum, CA.CardNumber,COL.[Card], CA.ActiveBalance, CA.Discount,CA.isEnabled
			FROM BASE bbb LEFT JOIN ZAKAZ_PLACE ZP ON ZP.ZPLACE=bbb.ZAKAZPLACE
			LEFT JOIN ZakazToContract ZTC ON ZTC.Zakaz=bbb.UniKey 
			LEFT JOIN CardOrderLink COL ON COL.[Order]=bbb.UNIKEY
			LEFT JOIN Cards CA ON CA.UniKey=COL.[Card]
			WHERE bbb.UniKey=@Unikey;
		return;
		end;

	if @R=5 /*    */
		begin
		SET @SQLString = N'SELECT bbb.*,ZP.PLACE_NAME,ZP.ImageIndex, isnull(ZTC.ClearingPrice,0.0) as ClearingPrice,ZTC.Contract,GR.NameGeoRegion as NameGeoRegionFrom, ZO.NameZone,ZT.TC_image_index,ZT.ZAKAZ_TYPE as ZakazTypeName,(CASE WHEN bbb.UltraKey IS NOT NULL AND bbb.isOwn=1 THEN (SELECT UC.GOV_NUMBER FROM UltraCars UC WHERE UC.UniKey=bbb.UltraCar)ELSE(SELECT GOV_NUMBER FROM Cars WHERE UniKey=[dbo].[GetCarByDriver](DRV.UNIKEY,GETDATE()))END)as GOV_NUMBER,
		CASE WHEN bbb.ZAKAZPLACE<100 THEN CAST(GETDATE()-isnull(bbb.DATETIME_OF_T,GETDATE()) as time) ELSE NULL END  as TIME_ZP_CHANGE, UT.TaxiName, UT.DispatchPhone
		FROM BASE bbb LEFT JOIN ZAKAZ_PLACE ZP ON ZP.ZPLACE=bbb.ZAKAZPLACE
		LEFT JOIN Zakaz_Type ZT ON ZT.UNIKEY=bbb.Zakaz_Type
		LEFT JOIN Zone ZO ON ZO.UNIKEY=bbb.ZoneFrom
		LEFT JOIN GeoRegions GR ON GR.UniKey=ZO.GeoRegion
		LEFT JOIN Drivers DRV ON DRV.UniKey=bbb.Driver
		LEFT JOIN UltraTaxi UT ON UT.ClientId=bbb.UltraAcceptor
		LEFT JOIN ZakazToContract ZTC ON ZTC.Zakaz=bbb.UniKey WHERE bbb.LOCKBAS=0 ';
		if @zakazplaceS IS NOT null SET @SQLString =@SQLString + N' AND zakazplace'+@zakazplaceS;
		if @SelectOrder IS NOT NULL SET @SQLString =@SQLString + @SelectOrder;
			else
			SET @SQLString =@SQLString + N'  ORDER BY bbb.TAXINUM ';
		Exec(@SQLString);
		return;
		end;
		
	if @R=6 /* */
		begin
		SELECT 'as' Phone;
		return;
		end;
	if @R=8 /*      */
		begin
		SELECT @PhoneKey=PhoneKey,@isDiscount=isDiscount,
			@Place=Place,@StreetFrom=StreetFrom,@StreetTo=StreetTo,@ZoneFrom=ZoneFrom,@ZoneTo=ZoneTo,@Price=Price,@ClientTel=ClientTel,
			@ZakazPlace=ZakazPlace,@Other=Other,@TimeOut=[TimeOut],@OtkazClienta=OtkazClienta,
			@HOUSEFROM=HOUSEFROM,@HOUSETO=HOUSETO,@TIMETOCLIENT=TIMETOCLIENT,@V_OPERATOR=V_OPERATOR,@V_RADIST=V_RADIST,
			@PREDV_DATETIME=PREDV_DATETIME,@PREDV_MIN=PREDV_MIN,@vip=vip,@hourpay=hourpay,@ZAKAZ_TYPE=ZAKAZ_TYPE,
			@DateBeginHourPay=DateBeginHourPay,@DateEndHourPay=DateEndHourPay,
			@KmBeginHourPay=KmBeginHourPay,@KmEndHourPay=KmEndHourPay, @GetAddSum=GetAddSum,@ModuleType=ModuleType,
			@isPredv=isPredv, @isAutoFineEnabled=isAutoFineEnabled, @PriceFull=PriceFull,
			@isKmEnabled=isKmEnabled,@isComplexEnabled=isComplexEnabled, @HourPayType=HourPayType,
			@Rate=Rate,@isClearing=isClearing,@isTaximeter=isTaximeter,@isAddMinPrice=isAddMinPrice,
			@GeoFrom=GeoFrom,@GeoTo=GeoTo,@StreetFromKey=StreetFromKey,@LatFrom=LatFrom,@LonFrom=LonFrom,
			@LatTo=LatTo,@LonTo=LonTo,@PreCalculatedPrice=PreCalculatedPrice,
			@LPSrc=LPSrc,@OrderSrc=OrderSrc
			FROM base WHERE UniKey=@UniKey;
		INSERT INTO base (DateIn,Place,StreetFrom,StreetTo,ZoneFrom,ZoneTo,Price,ClientTel,TaxiNum,ZakazPlace,Other,
		Lockbas,[TimeOut],OtkazClienta,HOUSEFROM,HOUSETO,TIMETOCLIENT,V_OPERATOR,V_RADIST,PREDV_DATETIME,
		PREDV_MIN,LASTUPDATE,vip,hourpay,ZAKAZ_TYPE,DRIVER,DateBeginHourPay,DateEndHourPay,KmBeginHourPay,KmEndHourPay,GetAddSum,
		ModuleType,isPredv,isAutoFineEnabled,PriceFull,	isKmEnabled,isComplexEnabled, HourPayType,PhoneKey,isDiscount,
		Rate,isClearing,isTaximeter,isAddMinPrice,isOwn,GeoFrom,GeoTo,StreetFromKey,LatFrom,LonFrom,LPSrc,OrderSrc,
		LatTo,LonTo,PreCalculatedPrice) 
		VALUES (
		GETDATE(),@Place,@StreetFrom,@StreetTo,@ZoneFrom,@ZoneTo,@Price,@ClientTel,0,@ZakazPlace,@Other,
		0,NULL,@OtkazClienta,@HOUSEFROM,@HOUSETO,@TIMETOCLIENT,@V_OPERATOR,@V_RADIST,@PREDV_DATETIME,
		@PREDV_MIN,GETDATE(),@vip,@hourpay,@ZAKAZ_TYPE,NULL,@DateBeginHourPay,@DateEndHourPay,
		@KmBeginHourPay,@KmEndHourPay,@GetAddSum,@ModuleType,@isPredv,@isAutoFineEnabled,@PriceFull,@isKmEnabled,
		@isComplexEnabled, @HourPayType,@PhoneKey,@isDiscount,@Rate,@isClearing,@isTaximeter,@isAddMinPrice,1,
		@GeoFrom,@GeoTo,@StreetFromKey,@LatFrom,@LonFrom,@LPSrc,@OrderSrc,@LatTo,@LonTo,@PreCalculatedPrice);
			
		SET @UNIKEY=SCOPE_IDENTITY();
		if @UNIKEY is not NULL
			EXEC [dbo].[history_up] @R=3,@BaseKey=@UNIKEY,@UserKey=@CurrentUserUniKey,@ActionKey=0, @driverkey=NULL;
		return;
		end;
	if @R=9 /* */
		begin
		BEGIN TRANSACTION;
		UPDATE base SET DateBegin=@DateBegin, DateTaxiWait=@DateTaxiWait, DateTaxiGo=@DateTaxiGo WHERE UniKey=@UniKey
		COMMIT TRANSACTION;		
		return;
		end;
END;
GO
SET ANSI_NULLS ON
GO
