ALTER PROCEDURE [dbo].[P_ADS] (@R int=1,
@AdsKey	int=null OUTPUT,
@DateBegin	datetime=null,
@DateEnd	datetime=null,
@ShortName	varchar(128)=null,
@AdsText	varchar(4000)=null,
@DateCreate	datetime=null,
@UserCreate	int=null,
@AdsType	int=null,
@CarType	int=null,
@SelectOrder varchar(1024)=NULL
)
AS
BEGIN
-- =============================================
-- Author:		<Alexey Ivakhin>
-- Create date: <24.12.2013>
-- Update date: <10.10.2014>
-- Description:	<   >
-- =============================================
SET DATEFORMAT dmy;
	DECLARE @Q varchar(4000), @KeyTmp int;
	--
	if @R=1
		begin
		SET @Q='SELECT ads.*,uuu.FIO, ZT.ZAKAZ_TYPE FROM ads LEFT JOIN USERS uuu ON uuu.UniKey=ads.UserCreate LEFT JOIN ZAKAZ_TYPE ZT ON ZT.UniKey=ads.CarType WHERE 1=1';
		if (@SelectOrder IS NOT NULL) SET @Q=@Q+@SelectOrder else SET @Q=@Q+' ORDER BY ads.datebegin DESC';
		Exec (@Q);
		return;
		end;
	--
	if @R=2
		begin
		INSERT INTO ads (DateBegin,DateEnd,ShortName,AdsText,AdsType,CarType,UserCreate) VALUES 
			(@DateBegin,@DateEnd,@ShortName,@AdsText,@AdsType,@CarType,@UserCreate)
		SET @AdsKey=SCOPE_IDENTITY();
		return;
		end;
	--
	if @R=3
		begin
		UPDATE ads SET DateBegin=@DateBegin,DateEnd=@DateEnd,ShortName=@ShortName,AdsText=@AdsText,AdsType=@AdsType,CarType=@CarType
			WHERE AdsKey=@AdsKey;
		return;
		end;
	--
	if @R=4
		begin
		DELETE FROM ads WHERE AdsKey=@AdsKey;
		return;
		end;
	--    /
	if @R=5
		begin
		SELECT ads.* from ads WHERE DateBegin<=GETDATE() AND (DateEnd IS NULL OR DateEnd>=GETDATE()) AND AdsType=@AdsType
			ORDER BY DateBegin;
		return;
		end;
		
END
