ALTER PROCEDURE [dbo].[P_SMS] (@R int=1,@UniKey int=null OUTPUT, @SmsState int=NULL,
@Phone varchar(20)=null, @SmsText varchar(512)=null,  @Priority int=0,
@Zakaz int=null,@Parent int=null,@isLocked bit=0,
@Channel int=NULL,
@ret bit=null OUTPUT,
@SelectOrder varchar(2000)=NULL, @Error varchar(2048)=null OUTPUT
)
AS
BEGIN
-- =============================================
-- Author:		<Alexey Ivakhin>
-- Create date: <09/12/2009>
-- Update date: <14/10/2014>
-- Description:	<  >
-- =============================================
SET DATEFORMAT dmy;
	SET NOCOUNT ON;
	DECLARE @UserID int,@Q varchar(4000);
	if @R=1
		begin
		SET @Q='SELECT sss.*,ST.StateName FROM SMS sss WITH (nolock) LEFT JOIN SMSState ST ON sss.SmsState=ST.UniKey WHERE 1=1 ';
		--if (@SmsState is NULL) SET @Q=@Q+' WHERE sss.SmsState NOT IN (5,7,8)';
		if (@SelectOrder is NOT NULL) SET @Q=@Q+@SelectOrder else SET @Q=@Q+' AND sss.SmsState NOT IN (5,7,8,9,10) ORDER BY sss.SmsState';
		--RaISERROR 99999 @Q;
		Exec (@Q);
		return;
		end;
	if @R=2 /**/
		begin
		UPDATE SMS SET Priority=@Priority, SmsState=@SmsState, SmsText=@SmsText, Phone=@Phone,
			Channel=@Channel,
			DateUpdate=GETDATE() WHERE UniKey=@UniKey;
		return;
		end;
	if @R=3 /**/
		begin
		INSERT INTO SMS (SmsState,SmsText,Phone,InOut,Parent,Priority,Channel) VALUES (@SmsState,@SmsText,
			[dbo].[GetPhoneFromPatternS](@Phone,1,NULL,1,NULL,NULL,NULL),1,@Parent,@Priority,@Channel);
		SET @UniKey= SCOPE_IDENTITY();
		return;
		end;
	if @R=4 /*  */
		begin
			UPDATE SMS SET SmsState=@SmsState WHERE UniKey=@Unikey;
		return;
		end;
	if @R=5 /*   */
		begin
			SELECT * FROM SMSState;
		return;
		end;
	if @R=6 /*      */
		begin
		DECLARE @WEBOrderStateWait int;
		SELECT TOP 1 @WEBOrderStateWait=WEBOrderStateWait FROM PROPERTIES;
		if object_id('tempdb..#tbl_smswww') is not null drop table #tbl_smswww;
		create table #tbl_smswww (UniKey int, SmsState int,Phone varchar(128),InOut bit, DateCreate DateTime,
			Zakaz int, ZakazModuleType int)
		-- SMS
		BEGIN TRY
			insert #tbl_smswww
			SELECT sss.UniKey,sss.SmsState,sss.Phone,sss.InOut,sss.DateCreate, Zakaz.UniKey ,2 
          FROM SMS sss (nolock)          outer apply
			(SELECT TOP(1) bbb.UniKey FROM BASE bbb WHERE bbb.CLIENTTEL LIKE sss.Phone AND bbb.ZAKAZPLACE<>100) Zakaz
			WHERE SmsState IN (1,4,6) AND isLocked=0;
		END TRY
		BEGIN CATCH
			SET @Error='SMS. '+ERROR_MESSAGE();
		END CATCH;

		-- WWW
		BEGIN TRY
			insert #tbl_smswww
			SELECT UniKey, WebState As SmsState, Phone, 0, DateCreate, Zakaz,3 FROM web WHERE WebState=@WEBOrderStateWait  AND isClosed=0 AND isLocked=0;
		END TRY
		BEGIN CATCH
			SET @Error='WWW. '+ERROR_MESSAGE();
		END CATCH;

		--   
		BEGIN TRY
			insert #tbl_smswww
			SELECT UniKey, 6, '('+isnull(CAST(dbo.GetCurrentTaxiNum(Driver,GETDATE()) as varchar),'-')+') '+dbo.GetFIO(Driver), 0, DateCreate, NULL,4 FROM DriverMessages WHERE InOut=0 AND isSend=0 AND isLocked=0;
		END TRY
		BEGIN CATCH
			SET @Error='DRIVER MESSAGES. '+ERROR_MESSAGE();
		END CATCH;
		
		--   
		BEGIN TRY
			insert #tbl_smswww
			SELECT DP.UniKeyPhoto, 6, '('+isnull(CAST(dbo.GetCurrentTaxiNum(Driver,GETDATE()) as varchar),'-')+') '+
			dbo.GetFIO(Driver), 0, DP.CreateDatePhoto, Driver,5 
			FROM DriversPhoto DP
			WHERE DP.isChecked=0
		END TRY
		BEGIN CATCH
			SET @Error='DRIVER PHOTOS. '+ERROR_MESSAGE();
		END CATCH;

		SELECT * FROM #tbl_smswww Order by InOut;
		return;
		end;
	if @R=7 /*  1     */
		begin
		SELECT sss.*,SZL.UserID,SZL.LinkDateCreate,SZL.Zakaz,
			(SELECT FIO FROM USERS WHERE UniKey=SZL.UserID) szlFIO FROM SMS sss WITH (nolock) LEFT JOIN SMSZakazLink SZL ON SZL.sms=sss.UniKey WHERE UniKey=@UniKey;
		return;
		end;
	if @R=8 /*    */
		begin
		SET @UserID=dbo.GetCurrentUserUniKey();
		INSERT INTO SMSZakazLink (Zakaz,sms,UserID) VALUES (@Zakaz,@UniKey,@UserID);
		--  SMS  
		DECLARE @SMSChannel int=NULL;
		SELECT @SMSChannel=SMSChannel FROM LPSrc WHERE UniKey=(SELECT LPSrc FROM BASE WITH(nolock) WHERE UniKey=@Zakaz);
		if (@SMSChannel IS NOT NULL)
			begin
			UPDATE SMS SET Channel=@SMSChannel WHERE UniKey=@UniKey;
			end;
		/*        */
		SET @UserID=NULL;
		SELECT TOP 1 @UserID=sss.UniKey FROM SMS sss WITH (nolock) LEFT JOIN SMSZakazLink SZL ON SZL.sms=sss.UniKey 
			WHERE SZL.zakaz=@Zakaz ORDER By sss.DateCreate;
		if (@UserID IS NOT NULL) UPDATE SMS SET Parent=@UserID WHERE UniKey=@UniKey;
		return;
		end;
	if @R=9 /*  SMS  */
		begin
		SELECT sss.*,ST.StateName,SZL.Zakaz FROM SMS sss WITH (nolock) LEFT JOIN SMSState ST ON sss.SmsState=ST.UniKey
			LEFT JOIN SMSZakazLink SZL ON SZL.sms=sss.UniKey WHERE SZL.Zakaz=@Zakaz; 
		return;
		end;
	if @R=10 /*    */
		begin
		DELETE FROM SMSZakazLink WHERE Zakaz=@Zakaz AND SMS=@UniKey;
		UPDATE SMS SET Parent=NULL WHERE UniKey=@UniKey;
		return;
		end;
	if @R=11 /*  -    */
		begin
			UPDATE SMS SET Parent=@Parent WHERE UniKey=@Unikey;
		return;
		end;
	if @R=12 /*     -    */
		begin
		declare @t table(UniKey int,InOut bit,SmsState int,SmsText varchar(512),Phone varchar(20),
			DateCreate datetime,DateUpdate datetime,Parent int,isLocked bit,Priority int,
			message_id int, OrderSrc int,Channel int,StateName varchar(32));
		insert @t
			SELECT sss.*,ST.StateName FROM SMS sss LEFT JOIN SMSState ST ON sss.SmsState=ST.UniKey WHERE sss.UniKey=@UniKey;
		-- 
		SELECT @Parent=Parent from sms WHERE UniKey=@UniKey;
			while (EXISTS(SELECT UniKey FROM SMS sss WHERE UniKey=@Parent) AND (@Parent is not NULL))
				begin
				insert @t
					SELECT sss.*,ST.StateName FROM SMS sss LEFT JOIN SMSState ST ON sss.SmsState=ST.UniKey WHERE sss.UniKey=@Parent;
				SELECT @Parent=Parent from sms WHERE UniKey=@Parent;
				end;
		-- 
		while (EXISTS(SELECT sss.UniKey FROM SMS sss WHERE sss.Parent=@UniKey) AND (@UniKey is not NULL))
			begin
			SELECT @UniKey=UniKey from sms WHERE Parent=@UniKey;
			insert @t
				SELECT sss.*,ST.StateName FROM SMS sss LEFT JOIN SMSState ST ON sss.SmsState=ST.UniKey WHERE sss.UniKey=@UniKey;
			end;
		SELECT * FROM @T;
		return;
		end;
	if @R=20 /*   */
		begin
			if ((@isLocked=1) AND (EXISTS(SELECT UniKey FROM SMS WITH (nolock) WHERE UniKey=@UniKey AND isLocked=0)))
				begin
				UPDATE SMS SET isLocked=1 WHERE UniKey=@Unikey;
				SET @ret=1;
				end 
				else SET @ret=0;
			if (@isLocked=0) UPDATE SMS SET isLocked=0 WHERE UniKey=@Unikey;
		return;
		end;
END
