ALTER PROCEDURE [dbo].[P_OtherServicesDriver](@R int=1, @OrderKey int=null, @Key int=null,@isSetByDriver bit=1)
AS
BEGIN
-- =============================================
-- Author:		<Alexey Ivakhin>
-- Create date: <18.02.2013>
-- Update date: <16.10.2014>
-- Description:	<   .       >
-- =============================================
SET DATEFORMAT dmy;
SET NOCOUNT ON
DECLARE @Rate int, @Price money,@OtherServicePercentPrice float, @ServiceName varchar(128),@PriceWithDiscount money;
--DECLARE @MsgText1 varchar(128),@CurLng varchar(2);
	if @R=1 /*   */
		begin
		SELECT @Rate=Rate FROM BASE WHERE UNIKEY=@OrderKey;
		IF (@Rate IS NULL) return;
		SELECT OS.UniKey as OtherService,OS.ServiceName,OS.Price,OS.PercentPrice,
			(SELECT COUNT(*) FROM BaseAdditionalServices CT WHERE CT.OrderKey=@OrderKey AND CT.OtherServiceKey=OS.UniKey) OSCOUNT,
			(SELECT SUM(CT.Price) FROM BaseAdditionalServices CT WHERE CT.OrderKey=@OrderKey AND CT.OtherServiceKey=OS.UniKey) OSSUM,
			isnull((SELECT OtherService FROM Rate_OtherService_Link_Driver WHERE Rate=@Rate AND OtherService=OS.UniKey),0) as Pos
			FROM OtherServices OS
			WHERE 
			OS.UniKey IN (SELECT OtherService FROM Rate_OtherService_Link_Driver WHERE Rate=@Rate)
			OR OS.UniKey IN (SELECT BAS.OtherServiceKey FROM BaseAdditionalServices BAS WHERE BAS.OrderKey=@OrderKey)
			ORDER BY Pos		
		return;
		end;
	if @R=2 /* .  */
		begin
		DELETE FROM BaseAdditionalServices WHERE OtherServiceKey=@Key AND OrderKey=@OrderKey;
		--   .  (    )
		SET @Price=[dbo].[F_GetFinalPriceFromPreCalculated](@OrderKey);
		IF @Price>0
			begin
			SET @PriceWithDiscount=[dbo].[getzakazdiscount](@OrderKey,@Price);
			if @PriceWithDiscount!=@Price
				UPDATE BASE SET PRICE=@PriceWithDiscount, PriceFull=@Price WHERE UniKey=@OrderKey;
				else
				UPDATE BASE SET Price=@Price WHERE UNIKEY=@OrderKey;
			end;
		return;
		end;
	if @R=3 /* .  */
		begin
		if (@isSetByDriver=1)
			begin
			--   
			if EXISTS (SELECT * FROM BaseAdditionalServices cc WHERE OtherServiceKey=@Key AND OrderKey=@OrderKey)
				begin
				return;
				end;
			end;
		Select @Price=Price,@OtherServicePercentPrice=OS.PercentPrice FROM OtherServices OS WHERE UniKey=@Key;
			--SELECT TOP 1 @CurLng=LngMain FROM PROPERTIES;
			--SELECT @MsgText1=LM.MessageText FROM LngMessages LM WHERE LM.LngKey=@CurLng AND LM.MessageName LIKE 'DB_ADD_SERVICE_SHORT';
			INSERT INTO BaseAdditionalServices (OtherServiceKey,OrderKey,Price,OtherServicePercentPrice,isSetByDriver) 
				VALUES(@Key,@OrderKey,@Price,@OtherServicePercentPrice,@isSetByDriver);
		--   .  (    )
		SET @Price=[dbo].[F_GetFinalPriceFromPreCalculated](@OrderKey);
		IF @Price>0
			begin
			SET @PriceWithDiscount=[dbo].[getzakazdiscount](@OrderKey,@Price);
			if @PriceWithDiscount!=@Price
				UPDATE BASE SET PRICE=@PriceWithDiscount, PriceFull=@Price WHERE UniKey=@OrderKey;
				else
				UPDATE BASE SET Price=@Price WHERE UNIKEY=@OrderKey;
			end;
		return;
		end;
	if @R=4 /*   */
		begin
		SELECT BAS.*,OS.ServiceName FROM BaseAdditionalServices BAS 
			LEFT JOIN OtherServices OS ON OS.UniKey=BAS.OtherServiceKey WHERE BAS.OrderKey=@OrderKey
			ORDER BY OS.ServiceName;
		return;
		end;
	if @R=5 /* .  */
		begin
		DELETE FROM BaseAdditionalServices WHERE UniKey=@Key;
		return;
		end;

END